tbb::internal::concurrent_queue_iterator< Container, Value > Class Template Reference
Containers

Meets requirements of a forward iterator for STL. More...

`#include <_concurrent_queue_impl.h>`

Inheritance diagram for tbb::internal::concurrent_queue_iterator< Container, Value >:
Collaboration diagram for tbb::internal::concurrent_queue_iterator< Container, Value >:

## Public Member Functions

| concurrent_queue_iterator ()
| concurrent_queue_iterator (const concurrent_queue_iterator< Container, typename Container::value_type > &other)
concurrent_queue_iterator & | operator= (const concurrent_queue_iterator< Container, typename Container::value_type > &other)
| Iterator assignment. More...
Value & | operator* () const
| Reference to current item. More...
Value * | operator-> () const
concurrent_queue_iterator & | operator++ ()
| Advance to next item in queue. More...
Value * | operator++ (int)
| Post increment. More...

## Private Member Functions

| concurrent_queue_iterator (const concurrent_queue_base_v3 &queue)
| Construct iterator pointing to head of queue. More...

## Friends

template<typename T , class A >
class | ::tbb::concurrent_bounded_queue

## Additional Inherited Members

Protected Member Functions inherited from tbb::internal::concurrent_queue_iterator_base_v3
| concurrent_queue_iterator_base_v3 ()
| Default constructor. More...
| concurrent_queue_iterator_base_v3 (const concurrent_queue_iterator_base_v3 &i)
| Copy constructor. More...
concurrent_queue_iterator_base_v3 & | operator= (const concurrent_queue_iterator_base_v3 &i)
__TBB_EXPORTED_METHOD | concurrent_queue_iterator_base_v3 (const concurrent_queue_base_v3 &queue)
| Obsolete entry point for constructing iterator pointing to head of queue. More...
__TBB_EXPORTED_METHOD | concurrent_queue_iterator_base_v3 (const concurrent_queue_base_v3 &queue, size_t offset_of_data)
| Construct iterator pointing to head of queue. More...
void __TBB_EXPORTED_METHOD | assign (const concurrent_queue_iterator_base_v3 &i)
| Assignment. More...
void __TBB_EXPORTED_METHOD | advance ()
| Advance iterator one step towards tail of queue. More...
__TBB_EXPORTED_METHOD | ~concurrent_queue_iterator_base_v3 ()
| Destructor. More...
Protected Attributes inherited from tbb::internal::concurrent_queue_iterator_base_v3
void * | my_item
| Pointer to current item. More...

## Detailed Description

### template<typename Container, typename Value>
class tbb::internal::concurrent_queue_iterator< Container, Value >

Meets requirements of a forward iterator for STL.

Value is either the T or const T type of the container.

Definition at line 1012 of file _concurrent_queue_impl.h.

## Constructor & Destructor Documentation

## concurrent_queue_iterator() [1/3]

template<typename Container , typename Value >

tbb::internal::concurrent_queue_iterator< Container, Value >::concurrent_queue_iterator | ( | const concurrent_queue_base_v3 & | queue | ) |

inline explicit private

Construct iterator pointing to head of queue.

Definition at line 1023 of file _concurrent_queue_impl.h.

:
concurrent_queue_iterator_base_v3(queue,__TBB_offsetof(concurrent_queue_base_v3::padded_page<Value>,last))
{
}
__TBB_offsetof
#define __TBB_offsetof(class_name, member_name)
Extended variant of the standard offsetof macro.
Definition: tbb_stddef.h:266
tbb::internal::last
auto last(Container &c) -> decltype(begin(c))
Definition: _range_iterator.h:40
tbb::internal::concurrent_queue_base_v3::padded_page
Definition: _concurrent_queue_impl.h:858
tbb::internal::concurrent_queue_iterator_base_v3::concurrent_queue_iterator_base_v3
concurrent_queue_iterator_base_v3()
Default constructor.
Definition: _concurrent_queue_impl.h:977

## concurrent_queue_iterator() [2/3]

template<typename Container , typename Value >

tbb::internal::concurrent_queue_iterator< Container, Value >::concurrent_queue_iterator | ( |  | ) |

inline

Definition at line 1029 of file _concurrent_queue_impl.h.

{}

## concurrent_queue_iterator() [3/3]

template<typename Container , typename Value >

tbb::internal::concurrent_queue_iterator< Container, Value >::concurrent_queue_iterator | ( | const concurrent_queue_iterator< Container, typename Container::value_type > & | other | ) |

inline

If Value==Container::value_type, then this routine is the copy constructor. If Value==const Container::value_type, then this routine is a conversion constructor.

Definition at line 1033 of file _concurrent_queue_impl.h.

:
concurrent_queue_iterator_base_v3(other)
{}

## Member Function Documentation

## operator*()

template<typename Container , typename Value >

Value& tbb::internal::concurrent_queue_iterator< Container, Value >::operator* | ( |  | ) | const

inline

Reference to current item.

Definition at line 1044 of file _concurrent_queue_impl.h.

{
return *static_cast<Value*>(my_item);
}
tbb::internal::concurrent_queue_iterator_base_v3::my_item
void * my_item
Pointer to current item.
Definition: _concurrent_queue_impl.h:974

References tbb::strict_ppl::internal::concurrent_queue_iterator_base_v3< tbb_remove_cv< Value >::type >::my_item.

## operator++() [1/2]

template<typename Container , typename Value >

concurrent_queue_iterator& tbb::internal::concurrent_queue_iterator< Container, Value >::operator++ | ( |  | ) |

inline

Advance to next item in queue.

Definition at line 1051 of file _concurrent_queue_impl.h.

{
advance();
return *this;
}
tbb::internal::concurrent_queue_iterator_base_v3::advance
void __TBB_EXPORTED_METHOD advance()
Advance iterator one step towards tail of queue.
Definition: concurrent_queue.cpp:643

References tbb::strict_ppl::internal::concurrent_queue_iterator_base_v3< tbb_remove_cv< Value >::type >::advance().

Here is the call graph for this function:

## operator++() [2/2]

template<typename Container , typename Value >

Value* tbb::internal::concurrent_queue_iterator< Container, Value >::operator++ | ( | int |  | ) |

inline

Post increment.

Definition at line 1057 of file _concurrent_queue_impl.h.

{
Value* result = &operator*();
operator++();
return result;
}
tbb::internal::concurrent_queue_iterator::operator++
concurrent_queue_iterator & operator++()
Advance to next item in queue.
Definition: _concurrent_queue_impl.h:1051
tbb::internal::concurrent_queue_iterator::operator*
Value & operator*() const
Reference to current item.
Definition: _concurrent_queue_impl.h:1044

References tbb::strict_ppl::internal::concurrent_queue_iterator< Container, Value >::operator*(), and tbb::strict_ppl::internal::concurrent_queue_iterator< Container, Value >::operator++().

Here is the call graph for this function:

## operator->()

template<typename Container , typename Value >

Value* tbb::internal::concurrent_queue_iterator< Container, Value >::operator-> | ( |  | ) | const

inline

Definition at line 1048 of file _concurrent_queue_impl.h.

{return &operator*();}

References tbb::strict_ppl::internal::concurrent_queue_iterator< Container, Value >::operator*().

Here is the call graph for this function:

## operator=()

template<typename Container , typename Value >

concurrent_queue_iterator& tbb::internal::concurrent_queue_iterator< Container, Value >::operator= | ( | const concurrent_queue_iterator< Container, typename Container::value_type > & | other | ) |

inline

Iterator assignment.

Definition at line 1038 of file _concurrent_queue_impl.h.

{
concurrent_queue_iterator_base_v3::operator=(other);
return *this;
}
tbb::internal::concurrent_queue_iterator_base_v3::operator=
concurrent_queue_iterator_base_v3 & operator=(const concurrent_queue_iterator_base_v3 &i)
Definition: _concurrent_queue_impl.h:984

References tbb::strict_ppl::internal::concurrent_queue_iterator_base_v3< Value >::operator=().

Here is the call graph for this function:

## Friends And Related Function Documentation

## ::tbb::concurrent_bounded_queue

template<typename Container , typename Value >
template<typename T , class A >

friend class ::tbb::concurrent_bounded_queue

friend

Definition at line 1017 of file _concurrent_queue_impl.h.

The documentation for this class was generated from the following file:

- _concurrent_queue_impl.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.